/*
 * Decompiled with CFR 0.152.
 */
package com.jiuqi.syntax;

import com.jiuqi.syntax.CommonData;
import com.jiuqi.syntax.CommonDatas;
import com.jiuqi.syntax.CustomFunctionListener;
import com.jiuqi.syntax.Function;
import com.jiuqi.syntax.FunctionParam;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.Calendar;
import java.util.Date;
import java.util.Hashtable;
import java.util.Map;

public final class AutoFunctionListener
extends CustomFunctionListener {
    private Object provider;
    private String classify;
    private Map funcMap;
    private static final int SY_FUNC_CALL_ERROR = 10400;
    private static final int SY_FUNC_RET_ERROR = 10401;
    private static final int SY_FUNC_ACL_ERROR = 10402;

    public AutoFunctionListener(Object provider) {
        this(provider, null);
    }

    public AutoFunctionListener(Object provider, String classify) {
        this.provider = provider;
        this.classify = classify;
        this.initFunctions();
    }

    private void initFunctions() {
        this.funcMap = new Hashtable();
        if (this.provider == null) {
            return;
        }
        Class<?> pc = this.provider.getClass();
        Method[] methods = pc.getDeclaredMethods();
        int i = 0;
        while (i < methods.length) {
            block6: {
                if (Modifier.isPublic(methods[i].getModifiers())) {
                    Function func = new Function();
                    func.name = methods[i].getName();
                    func.resultType = this.convertType(methods[i].getReturnType());
                    if (func.resultType != 0) {
                        func.classify = this.classify;
                        Class<?>[] paramTypes = methods[i].getParameterTypes();
                        int j = 0;
                        while (j < paramTypes.length) {
                            FunctionParam param = new FunctionParam();
                            param.name = "p" + Integer.toString(j);
                            param.type = this.convertType(paramTypes[j]);
                            if (param.type != 0) {
                                param.canOmit = false;
                                param.isSign = false;
                                func.params.add(param);
                                ++j;
                                continue;
                            }
                            break block6;
                        }
                        this.functions.add(func);
                        this.funcMap.put(func, methods[i]);
                    }
                }
            }
            ++i;
        }
    }

    private int convertType(Class typeClass) {
        if (Integer.TYPE.equals(typeClass) || Integer.class.equals((Object)typeClass)) {
            return 1;
        }
        if (Double.TYPE.equals(typeClass) || Double.class.equals((Object)typeClass)) {
            return 2;
        }
        if (String.class.equals((Object)typeClass)) {
            return 3;
        }
        if (Boolean.TYPE.equals(typeClass) || Boolean.class.equals((Object)typeClass)) {
            return 5;
        }
        if (Calendar.class.equals((Object)typeClass)) {
            return 6;
        }
        return 0;
    }

    public String getClassify() {
        return this.classify;
    }

    public int callFunction(String funcName, CommonDatas paramValues, CommonData resultData, boolean isCheckMode) {
        Function func = this.functions.getFunc(funcName);
        if (func == null) {
            return 201;
        }
        Method method = (Method)this.funcMap.get(func);
        try {
            Object[] args = this.convertParams(paramValues, func);
            Object ret = method.invoke(this.provider, args);
            resultData.type = func.resultType;
            if (!this.convertObject(ret, resultData)) {
                return 10401;
            }
        }
        catch (SyntaxException e) {
            return e.getErrorCode();
        }
        catch (IllegalArgumentException illegalArgumentException) {
            return 202;
        }
        catch (IllegalAccessException illegalAccessException) {
            return 10402;
        }
        catch (InvocationTargetException e) {
            e.printStackTrace();
            return 10400;
        }
        return 0;
    }

    private Object[] convertParams(CommonDatas paramValues, Function func) throws SyntaxException {
        Object[] params = new Object[func.params.size()];
        int i = 0;
        while (i < func.params.size()) {
            CommonData value;
            CommonData commonData = value = paramValues.size() <= i ? null : paramValues.getItem(i);
            if (value == null || value.isNull) {
                params[i] = null;
            } else {
                switch (func.params.getParam((int)i).type) {
                    case 1: {
                        params[i] = new Integer((int)value.getIntRealValue());
                        break;
                    }
                    case 2: {
                        params[i] = new Double(value.getIntRealValue());
                        break;
                    }
                    case 3: {
                        params[i] = value.cdString;
                        break;
                    }
                    case 5: {
                        params[i] = new Boolean(value.cdBool);
                        break;
                    }
                    case 6: {
                        params[i] = value.cdDate;
                        break;
                    }
                    default: {
                        throw new SyntaxException(202);
                    }
                }
            }
            ++i;
        }
        return params;
    }

    /*
     * Enabled force condition propagation
     * Lifted jumps to return sites
     */
    private boolean convertObject(Object value, CommonData result) {
        if (value == null) {
            result.isNull = true;
            result.initNullValue();
            return true;
        } else {
            result.isNull = false;
            switch (result.type) {
                case 1: {
                    if (value instanceof Integer) {
                        result.cdInt = (Integer)value;
                        return true;
                    }
                    if (!(value instanceof Double)) return false;
                    result.cdInt = ((Double)value).intValue();
                    return true;
                }
                case 2: {
                    if (value instanceof Integer) {
                        result.cdReal = ((Integer)value).intValue();
                    } else {
                        if (!(value instanceof Double)) return false;
                        result.cdReal = (Double)value;
                    }
                }
                case 3: {
                    result.cdString = value.toString();
                    return true;
                }
                case 5: {
                    if (!(value instanceof Boolean)) return false;
                    result.cdBool = (Boolean)value;
                    return true;
                }
                case 6: {
                    if (value instanceof Calendar) {
                        result.cdDate = (Calendar)value;
                        return true;
                    }
                    if (value instanceof Date) {
                        result.setDateValue((Date)value);
                        return true;
                    }
                    if (!(value instanceof Long)) return false;
                    Calendar date = Calendar.getInstance();
                    date.setTimeInMillis((Long)value);
                    result.cdDate = date;
                    return true;
                }
                default: {
                    return false;
                }
            }
        }
    }

    public String getCodeMessage(int retCode) {
        switch (retCode) {
            case 10400: {
                return "函数调用时出现程序异常";
            }
            case 10401: {
                return "错误的函数返回值类型";
            }
            case 10402: {
                return "类或函数无法访问";
            }
        }
        return null;
    }

    private class SyntaxException
    extends Exception {
        private int errorCode;

        public SyntaxException(int errorCode) {
            this.errorCode = errorCode;
        }

        public int getErrorCode() {
            return this.errorCode;
        }
    }
}

